/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2015 Frederik Heber. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * AtomNameDescriptor.cpp
 *
 *  Created on: Jun 2, 2015
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "CodePatterns/MemDebug.hpp"

#include <string>

#include "AtomNameDescriptor.hpp"
#include "AtomNameDescriptor_impl.hpp"

#include "Atom/atom.hpp"
#include "CodePatterns/Observer/ObservedContainer_impl.hpp"

using namespace std;


AtomNameDescriptor_impl::AtomNameDescriptor_impl(const std::string _name) :
  name(_name)
{}

AtomNameDescriptor_impl::~AtomNameDescriptor_impl()
{}

bool AtomNameDescriptor_impl::predicate(std::pair<atomId_t,const atom*> atom) const {
  return atom.second->getName() == name;
}

AtomDescriptor AtomByName(const std::string _name){
  return AtomDescriptor(AtomDescriptor::impl_ptr(new AtomNameDescriptor_impl(_name)));
}
